//**********************
//*****  Includes  *****
//**********************

#include "exec/types.h"

// * Numbers in () is the size of each field.

// * UBYTE & BYTE               = 1 Byte
// * UWORD, WORD, SHORT, USHORT = 2 Bytes
// * ULONG, LONG, int           = 4 Bytes

struct Globals
{
 TEXT activity[20];    // ( 20) Activity Name

 BYTE AN,              // (  1) Activity Number
      aborttransfer,   // (  1) Abort Transfer
      frontend,        // (  1)
      frontendstatus,  // (  1)
      hide,            // (  1) User hidden from who display
      kickuser,        // (  1)
      mute,            // (  1) User is in mute status
      shutdown;        // (  1)

 long ULCPS,           // (  4) UL CPS
      DLCPS,           // (  4) DL CPS
      CurrentBaudRate; // (  4)

 char ULFileName[100], // (100) Current UL FileName
      DLFileName[100]; // (100) Current DL FileName

 long ULPosition,      // (  4) Position of current file being uploaded
      DLPosition,      // (  4) Position of current file being downloaded

      ULFileSize,      // (  4) FileSize of current file being uploaded
      DLFileSize,      // (  4) FileSize of current file being downloaded

      ULBytes_Xfered,  // (  4) Total UL Bytes Transfered
      ULFiles_Xfered,  // (  4) Total UL Files Transfered

      DLBytes_Xfered,  // (  4) Total DL Bytes Transfered
      DLFiles_Xfered;  // (  4) Total DL Files Transfered

 BYTE ChatFlag,        // (  1) Sysop Avaialable Flag On       (1=Yes, 0=No) NOT ACTIVE YET
      TempSysopAccess; // (  1) Temporary Sysop Access Flag On (1=Yes, 0=No)

 UBYTE AreaType;       // (  1) What kind of area.  0=Msg Area, 1=File Area

 ULONG JoinedArea,     // (  4) Current Area joined.
       JoinedSubArea;  // (  4) Current Sub File Listing being used.

 TEXT ChatReason[50];  // ( 50) Operator Page Reason

 BYTE HydraDone;       // (  1)

 char LargeFiller[2940]; // (2940) Blank data for Future Use.
};


//*************************
//*************************
//*************************
//*****  Struct User  *****  FiLE: Accounts.Data
//*************************
//*************************
//*************************

struct User
{
 UWORD   Slot_Number;            // (  2) Account#
 UBYTE   Status;                 // (  1) 0=Deleted, 1=Active, 2=New User, 3=Locked Out, 4=Created Account

 TEXT    Name[31],               // ( 31) Users Name
         RealName[26],           // ( 26) Real Name
         VoicePhone[21],         // ( 21) Voice Phone Number
         DataPhone[21],          // ( 21) Data  Phone Number
         Address[26],            // ( 26) Address
         City[26],               // ( 26) City
         State[4],               // (  4) State/Providence Code
         Country[4],             // (  4) Country Code
         MailRoute[15],          // ( 15) Zip Code / Mail Route
         ComputerType[21],       // ( 21) Computer Type (Possible Code Instead)
         Password[16],           // ( 16) Password
         Comment[31];            // ( 31) Comment String

 UBYTE   Security;               // (  1) Access Level
 UWORD   WeedDays,               // (  2) Days of inactivity until bbs auto deletes
         ReduceDays;             // (  2) Days Paid for by a payer.                        (NOT USED YET)
 UBYTE   ReducedAccess;          // (  1) Preset level to give to user after reduced days  (NOT USED YET)

 UBYTE   AnsiType,               // (  1) Ansi Type  0) Normal, 1) Amiga, 2) IBM, 3) RIP
         Protocol,               // (  1) Protocol Selected: 0:Zmodem 1:Hydra
         DEADProto,              // (  1) Not Used Anymore
         HelpLevel,              // (  1) Level of Help
         MSGHeader,              // (  1) Msg Header Type
         EditorLines,            // (  1) Max Lines allowed in Editor      (NOT USED YET)
         DescLines,              // (  1) File Listing lines, Descriptions
         ViewMode,               // (  1) File Listing View Mode
         WhoPrefs,               // (  1) Who Preferences
         MB_J,                   // (  1) Message Rejoin
         FB_J,                   // (  1) File rejoin
         Length,                 // (  1) Length of screen
         Width,                  // (  1) Width of screen
         Language,               // (  1)
         Translation,            // (  1) (NOT USED YET)
         TimeZone,               // (  1) Time Zone Offset (NOT USED YET)
         BirthDate_Day,          // (  1) DAY of birth
         BirthDate_Month,        // (  1) MONTH of birth
         BirthDate_Year,         // (  1) YEAR of birth
         IdleTime,               // (  1) Idle time allowed for no activity (NOT USED YET)
         NodeLastOn;             // (  1) Last node user was on

 UWORD   ForwardMailSlot,        // (  2) Slot Number of user to forward mail to! (NOT USED YET)
         PWF;                    // (  2) Number of Password Failures

 UWORD   Total_Calls,            // (  2) # of Calls Total
         Total_Posts,            // (  2) Msgs left total
         Total_PostsReceived,    // (  2) Msgs Received
         Total_ULFiles,          // (  2) # of Uploads
         Total_DLFiles,          // (  2) # of Downloads
         Total_TimeBank;         // (  2) Time Bank Value
 ULONG   Total_ULBytes,          // (  4) Total Uploaded Bytes
         Total_DLBytes;          // (  4) Total Downloaded Bytes

 UWORD   Limit_Calls,            // (  2) Calls ALLOWED per Day
         Limit_Posts,            // (  2) Messages Allowed p/d
         Limit_ULFiles,          // (  2) # of Uploads Per Period
         Limit_DLFiles,          // (  2) # of Downloads Per Period
         Limit_Time,             // (  2) Time Limit per day.
         Limit_TimeBank,         // (  2)
         Limit_ChatTime;         // (  2) Limit of Time user can be in chat door
 ULONG   Limit_ULBytes,          // (  4) Limit Upload Bytes Per Period
         Limit_DLBytes;          // (  4) Limit Download Bytes Per Period

 UBYTE   F_Ratio,                // (  1) File Ratio
         B_Ratio;                // (  1) Byte Ratio

 UBYTE   Period_Type;            // (  1) Mins, Hours, Days, Weeks, Months, Years    (NOT USED YET)
 UWORD   Period_Length,          // (  2) 24 hours or whatever! Set Limits by Period (NOT USED YET)
         Period_Calls,           // (  2) Calls made  Today
         Period_Posts,           // (  2) Todays Msgs Sent
         Period_ULFiles,         // (  2) Todays Ul's
         Period_DLFiles,         // (  2) Todays Dl's
         Period_ChatTime;        // (  2) Time user has been in chat this period
 ULONG   Period_ULBytes,         // (  4) Period Bytes Uploaded
         Period_DLBytes;         // (  4) Period Bytes Downloaded

 UWORD   Left_DLFiles,           // (  2) Files left available for download
         Left_ChatTime,          // (  2) Limit of Time user can be in chat door
         Left_Time;              // (  2) Time Left
 ULONG   Left_DLBytes;           // (  4) Bytes left for this period

 UWORD   DayCredits,             // (  2) For Payers
         FileCredits;            // (  2) Files Paid for by a payer.

 ULONG   ByteCredits,            // (  4) Bytes Paid for by a payer.
         PersonalBytes,          // (  4) Personal Area Bytes Limit
         LastBaudRate;           // (  4) Last Baud Rate of a user.

 LONG    Time_First_Called,      // (  4) Time First Logged On
         Time_Last_Logoff,       // (  4) Last Time LOGGED OFF
         Time_Last_Connect;      // (  4) Time last CONNECTED

LONGBITS UserBitsA,              // (  4)
         UserBitsB,              // (  4)
         UtilBits,               // (  4) 32 bits for Programmers to use as they wish for utils.
         LastCallFlags,          // (  4) Flags for activities during last call. Posted,UL,DL,etc (NOT USED YET)
         CatFlags,               // (  4) Flags for Custom File Listing (NOT USED YET)
         NFlags1,                // (  4) Normal Flags Part 1
         NFlags2,                // (  4) Normal Flags Part 2
         SFlags1,                // (  4) Sysop  Flags Part 1
         SFlags2;                // (  4) Sysop  Flags Part 2

 char    MsgBase[41],            // (1x41=41) MB 0-39 Flags N,Y,S   // Change to 2 LONGBITS
         FileBase[41];           // (1x41=41) FB 0-39 Flags N,Y,S   // one for normal, one for sysop

 UWORD   Last_Read_Message[40],  // (40x2=80) -position change- Last read pointer
         Last_Scan_Message[40];  // (40x2=80)

 BYTE    AnsiColor;              // (  1) Ansi Color
 BYTE    BExtras[29];            // (1x29=29)

 UWORD   CheckSum,               // (  2)
         SerialNumber;           // (  2) Unique seiral number for flagged files, etc. (NOT USED YET)

 SHORT   SExtras[3];             // (3x2=6)
 LONG    LExtras[3];             // (3x4=12)
};

struct Csum
{
 UWORD Csum; // (  2)
};

//*******************************
//*******************************
//*******************************
//*****  Struct SystemData  ***** FiLE: SystemData.Data - (GLOBAL SETTINGS!)
//*******************************
//*******************************
//*******************************

struct SystemData
{
 TEXT  Name[31],                  // ( 31) Name of BBS System
       Location[51],              // ( 51) Location of BBS System
       SysopName[31],             // ( 31) Sysop's Name

       // System Paths

       MainPath[41],              // ( 41) Main Path & Accounts.data

       NotUsed1[40],              // ( 40) Not Used

       AccountInfoPath[41],       // ( 41) Path to User Info Files

       NotUsed2[40],              // ( 40) Not Used

       CatalogsPath[41],          // ( 41) Path to Catalog files

       NotUsed3[121],             // (121) Not Used

       LogsPath[41],              // ( 41) path for Log & transcript

       NotUsed4[162],             // (162) Not Used

       TextDirPath[41],           // ( 41) Path to Text Directory

       NotUsed5[80],              // ( 80) Not Used

       UploadPath[41],            // ( 41) Path for all uploads and resume directory

       NotUsed6[40],              // ( 40) Not Used

       DoorsPath[41],             // ( 41) Door Path

       NotUsed7[202],             // (202) Not Used
                                         
       // Passwords

       LocalAccessPassword[21],   // ( 21) Password: Local Access (Sysop/Local Logins)
       SysopCmdsPassword[21],     // ( 21) Password: Sysop Commands
       NewUserPassword[21],       // ( 21) Password: New User's to apply
       SystemEntryPassword[21],   // ( 21) Password: Users to enter system

       // Scripts

       LocalShell[101],           // (101) command to launch local cli

       NotUsed8[101],             // (101) NOT USED

       FontName[31],              // ( 31) Font Name

       RemoteShellPassword[21],   // ( 21) Password: Local Shell Access
       LocalLogonPassword[21],    // ( 21) Password: Local Logon Password

       NotUsed9[81],              // ( 81) Not Used

       PresetD[16][26],           // (16x26=416) Descriptions of Presets

       BBSConfigPassword[21],     // ( 21) Password: BBSConfig Module

       Phone[31],                 // ( 31) BBS Phone Number

       NotUsed10[50],             // ( 50) Not Used

       SystemDescSeperater[81],   // ( 81) Defineable Description Seperator.

       CHAR_Extra[2278];          // (2278)
 //________________________________________________________________________

 UBYTE LockViewMode,              // (  1) View mode to lock users into
       Chat_H,                    // (  1) Chat Color for USER
       Chat_M,                    // (  1) Chat Color for SYSOP
       ULRewardP_Time,            // (  1) Percentage of time gained for uploads
       MaxPages,                  // (  1) Maximum time user can page sysop per call
       WindowToFront,             // (  1) window to front

       ChatMethod,                // (  1) Default Sysop Chat Method (0=Normal,1=Horizontal,2=Vertical)

       BitPlanes,                 // (  1) Bit Planes
       Auto_Iconify,              // (  1) 0: open normal  1: open into icon
       BackGround,                // (  1) BBS screen to back ground
       UseWBReal,                 // (  1) Use Workbench Screen for Real Nodes.
       UseWBLocal,                // (  1) Use WOrkbench Screen for Local Nodes.
       HALFSCREEN,                // (  1) Half Screen Mode (1)
       NotUsedUBYTE1,             // (  1)
       LNBitPlanes,               // (  1) Bit Planes for Local Nodes

       Auto_IconifyL,             // (  1) Local Nodes (auto iconify or not)
       BackGroundL,               // (  1) BBS screen to back ground (local)

       ASLRequesters,             // (  1) 0=Ask, 1=Always Use, 2=Never Use

       SystemFlags[108],          // (1x108=108)

       ULRewardP_DLCredits,       // (  1) Download Credits for a day for uploads

       AttemptsName,              // (  1) User Name Attempts
       AttemptsPass,              // (  1) User Password Attempts
       AttemptsSysP,              // (  1) System Password Attempts
       AttemptsNewU,              // (  1) New User Password Attempts

       PassMinimum,               // (  1) Minimum characters required for user passwords.

       MAXDLINES,                 // (  1) Maximum Description Lines Allowed

       FontStyle,                 // (  1)
       FontFlags,                 // (  1)

       LogType,                   // (  1) 0 = Remote Only, 1 = Local Only, 2 = All Nodes

       UBYTE_Extras[86];          // (1x86=86)

 BOOL  AutoScroll,                // (  2) Auto Scroll Screen Mode (Real Nodes)
       AutoScrollL;               // (  2) Auto Scroll Screen Mode (Local Nodes)

 //________________________________________________________________________

 WORD  NumberOfLines,             // (  2) Total Number of Nodes

       NotUsedWord1,              // (  2)
       NotUsedWord2,              // (  2)

       MaxEditorLines,            // (  2) Max number of editor lines allowed for msg editor.
       MaxFlaggedFiles,           // (  2) Max number of flagged files allowed at one time.

       WORDExtras[30];            // (2x30=60)

 UWORD SWidthL,                   // (  2) Screen Width  (Local Nodes)
       SHeightL,                  // (  2) Screen Height (Local Nodes)
       OverScanTypeL,             // (  2) Overscan type (Local Nodes)
       SWidth,                    // (  2) Screen Width  (Real Nodes)
       SHeight,                   // (  2) Screen Height (Real Nodes)
       OverScanType;              // (  2) Overscan type (Real Nodes)
 //________________________________________________________________________

 int   FontSize,                  // (  4) 8: Defualt
       MaxUsers,                  // (  4) Maximim User's allowed on system

       BBSPriority,               // (  4) Normal Priority
       FileTransferPriority,      // (  4) File Trasfer Priority
       DoorsPriority,             // (  4) Doors Priority
       ExtraPriority,             // (  4)

       INT_Extras[26];            // (4x26=104)
 //________________________________________________________________________

 long  LowFreeSpace,              // (  4) Low point for warning of low harddrive space
       NoFreeSpace,               // (  4) Required harddrive space for uploads

       MaxSizeViewText,           // (  4) Max size of a file that can be viewed
                                  // (  4) with online view text file command.

       SystemFlags1,              // (  4) System Flags (32 Flags) #1
       SystemFlags2,              // (  4) System Flags (32 Flags) #2
       SystemFlags3,              // (  4) System Flags (32 Flags) #3
       SystemFlags4,              // (  4) System Flags (32 Flags) #4
       SystemFlags5,              // (  4) System Flags (32 Flags) #5
       SystemFlags6,              // (  4) System Flags (32 Flags) #6
       SystemFlags7,              // (  4) System Flags (32 Flags) #7
       SystemFlags8,              // (  4) System Flags (32 Flags) #8

       LogFlags,                  // (  4) Log Flags (32 Flags)

       CatalogFlags,              // (  4) Custom Catalog On/Off Switchs.

       CopyBuffer,                // (  4) Defineable Copy Buffer

       LONG_Extras[26];           // (4x26=104)

  ULONG DisplayIDL,               // (  4) For Screen Mode (Local Nodes)
        DisplayID;                // (  4) For Screen Mode (Real Nodes)
};

//*******************************
//*******************************
//*******************************
//*****  Struct NodeData  ******* FiLE: NodeData-x.Data - (PER NODE SETTINGS!)
//*******************************
//*******************************
//*******************************

struct NodeData
{
 TEXT  NotUsed1[264],             // (264) Not Used

       // Modem Information

       DeviceName[31],            // ( 31) serial.device

       NotUsed2[50],              // ( 50) Not Used

       Open[61],                  // ( 61) Modem INIT string
       Reset[31],                 // ( 31) Hangup/reset string
       Ring[31],                  // ( 31) RING DETECTED string
       Answer[31],                // ( 31) What to do when a ring
       Busy[31],                  // ( 31) to make the modem off-hook
       OnHook[21],                // ( 21) to make modem on-hook
       Escape[21],                // ( 21) to get modems attention

       NotUsed3[102],             // (102) Not Used

       NodePassword[21],          // ( 21) Password for this node!

       CHAR_Extra[2979];          //(2979) Not Used
 //________________________________________________________________________

 UBYTE LocalMode,                 // (  1) 0: Serial routines active  1:View Mode
       Serial_Shared,             // (  1) 0: Normal,  1: Open in shared mode
       AutoLoad,                  // (  1) 0: Yes,     1: No
       HandShake,                 // (  1) 0: RTS/CTS 1: XON/XOFF 2:NONE

       DTR,                       // (  1) 0: No, 1: Yes Drop DTR on Hangup

       Parity,                    // (  1) 0:None 1:Even 2:Odd 3:Mark 4:Space
       BitsChar,                  // (  1) 0:8 Bits 1:7 Bits
       RAD_BOG,                   // (  1) 0:off  1:on
       StopBits,                  // (  1) 0:1 Bit 1:2 Bits

       NotUsed5,                  // (  1) Not Used

       Parse,                     // (  1) 0:Parse 1:quick

       NotUsed6,                  // (  1) Not Used

       FLUSH,                     // (  1) 0: Normal  1:FLUSH SERIAL

       NotUsed7,                  // (  1) Not Used

       TIMEOT,                    // (  1) 30(Defalut) for hangu[p on incomming call

       NotUsed8,                  // (  1)
       NotUsed9,                  // (  1)
       NotUsed10,                 // (  1)
       NotUsed11,                 // (  1)
       NotUsed12,                 // (  1)

       Define[119],               // (119) Define Flags

       PrinterDumpStatus,         // (  1)
       DEAD6,                     // (  1)
       DEAD7,                     // (  1)
       DEAD8,                     // (  1)
       Sleeplogoff,               // (  1) Time before sleep logoff - was Define[41]
       NotUsed13,                 // (  1)
       NotUsed14,                 // (  1)
       NotUsed15,                 // (  1)
       MinAccessLevel,            // (  1) Minimum access level to logon to this node.
       LoadedLanguage,            // (  1) Current Loaded Lanugage
       NumberOfRings,             // (  1) Number of rings before modem picks up.
       ModemPauseDelay,           // (  1) Delay for modem pause.
       ModemCharDelay,            // (  1) Delay in between characters.

       ReadWriteBufferSize,       // (  1) in KB
       SerialBufferSize,          // (  1) in KB

       BYTE_Extras[86];           // ( 86)
 //________________________________________________________________________

 WORD  CurrentNode,               // (  2) Current Node #

       WORDExtras[40];            // (2x40=80)
 //________________________________________________________________________

 int   SerialDeviceNumber,        // (  4) serial device unit #  (ULONG)
       DeadF1,                    // (  4) Not Used
       DEADFLAG1,                 // (  4) Not Used
       DEADFLAG2,                 // (  4) Not Used
       DEADCRAP,                  // (  4) Not Used

       FrontEnd,                  // (  4) Front End Flag

       DEADFLAG3,                 // (  4) Not Used

       INT_Extras[28];            // (4x28=112)
 //________________________________________________________________________

 long  HighestBaudRate,           // (  4) Highest BAUD RATE / DTE Rate
       MinBaudRate,               // (  4) Minimum Baud Rate

       NodeFlags1,                // (  4) Node Flags (32 Flags) #1

       NodeFlags2,                // (  4) Node Flags (32 Flags) #2
       NodeFlags3,                // (  4) Node Flags (32 Flags) #3
       NodeFlags4,                // (  4) Node Flags (32 Flags) #4
       NodeFlags5,                // (  4) Node Flags (32 Flags) #5
       NodeFlags6,                // (  4) Node Flags (32 Flags) #6
       NodeFlags7,                // (  4) Node Flags (32 Flags) #7
       NodeFlags8,                // (  4) Node Flags (32 Flags) #8

       LONG_Extras[30];           // (4x30=120)
};
//=========================================================================
//*****************************
//*****************************
//*****  Struct Msg_Area  ***** FiLE: Messages.data
//*****************************
//*****************************
//=========================================================================
struct Msg_Area
{
 TEXT     Name[31],       // ( 31) Name of Area
          What[41],       // ( 41) Description of Area
          Path[51],       // ( 51) Path
          Password[21],   // ( 21) Password
          EChar[50];      // ( 50)

 BYTE     ON,             // (  1) On/Off Switch
          Sex,            // (  1) Sex Type Allowed (M,F,B)
          EBYTE[20];      // ( 20)

 UBYTE    AccessLevel,    // (  2) Minimum Access Level Required
          Area,           // (  2) Area Number
          MinAge,         // (  2) Minimum Age to enter
          MaxAge,         // (  2) Maximum Age allowed to enter
          Allow,          // (  2) DEAD FLAG - 0 = All, 1=Private Only, 2=Public Only, 3=Aynonoums Only
          EUBYTE[19];     // (2x19=38)

 WORD     RollOver,       // (  2)
          WExtras[4];     // (2x4=8)

 int      Eint[4];        // (4x4=16)
 long     ELong[5];       // (4x5=20)

 LONGBITS Flags1,         // (  4)
          Flags2;         // (  4)
};

#define MA1_ALLOW_MSGREAD  (1<<0) // Allow Users to read messages  (0=On,1=Off)
#define MA1_ALLOW_MSGPOST  (1<<1) // Allow Users to write messages (0=On,1=Off)

#define MA1_ALLOW_PUBLIC   (1<<2) // Allow Public Msgs             (0=On,1=Off)
#define MA1_ALLOW_PRIVATE  (1<<3) // Allow Private Msgs            (0=On,1=Off)
#define MA1_ALLOW_ANON     (1<<4) // Allow Anonymous Msgs          (0=On,1=Off)
#define MA1_ALLOW_EALL     (1<<5) // Allow EALL's / Priority Mail. (0=On,1=Off)

#define MA1_ALLOW_EDIT     (1<<6) // Allow Edit of existing messages. (0=On,1=Off)
#define MA1_ALLOW_ULPOST   (1<<7) // Allow Msgs to be uploaded        (0=On,1=Off)
#define MA1_ALLOW_ATTACH   (1<<8) // Allow Files to be attached to messages. (0=On,1=Off)
#define MA1_FORCE_ANON     (1<<9) // Force Amonymous Messages (0=NO, 1=YES)

//#define MA1_
//#define MA1_
//#define MA1_
//#define MA1_
//#define MA1_
//#define MA1_
//#define MA1_
//=========================================================================
//******************************
//******************************
//*****  Struct File_Area  ***** FiLE: Files.data
//******************************
//******************************
//=========================================================================
struct File_Area
{
 TEXT     Name[31],       // ( 31) Name of Area
          What[41],       // ( 41) Description of Area
          Path[51],       // ( 51) Path
          Password[21],   // ( 21) Password to enter.
          EChar[50];      // ( 50)

 BYTE     DelMonths,      // (  1) Deletion Months, 0 = Disabled.
          ON,             // (  1) On/Off Switch
          Sex,            // (  1) Sex Type Allowed (M,F,B)

          ULTimesCredit,  // (  1) How many times credit a user gets given for uploads
          DLTimesCredit,  // (  1) How many times credit a user gets taken for downloads
                          //       0 & 1 both give 1x credit, to give no credits there is
                          //       another flag for that.
          EBYTE[18];      // ( 18)

 UBYTE    AccessLevel,    // (  1) Minimum Access Level Required
          Area,           // (  1)
          MinAge,         // (  1)
          MaxAge,         // (  1)
          ULTimeReward,   // (  1) Upload Time Reward Percentage.
          DLTimeReward,   // (  1) Download Time Reward Percentage.
          DLBonusReward,  // (  1) Reward given to upload for every download of his UL's
          FileIDDetection,// (  1) Dead Flag!
          FileIDCreation, // (  1) Dead Flag!
          Allow,          // (  1) Dead Flag!
          Catalogs,       // (  1) Number of Catalog Listings in Area
          MaxFNLength,    // (  1) Max FileName Length Allowed in this area

          EUBYTE[15];     // ( 15)

 WORD     RollOver,       // (  2) (NOT USED YET)
          WExtras[4];     // (2x4=8)
 int      Eint[4];        // (4x4=16)
 long     ELong[5];       // (4x5=20)

 LONGBITS Flags,          // (  4)
          Flags2;         // (  4)
};
// Flags Bits

#define FA_FREEDL         (1<<2) // All files are free donwload?     0=No, 1=Yes
#define FA_NOULCREDITS    (1<<3) // No Upload Credits for this area. 0=Credits, 1=No
#define FA_AUTOVALIDATE   (1<<4) // Files are auto validated?        0=Yes, 1=No
#define FA_ALLOW_UPLOAD   (1<<5) // Allow Uploading                  0=Yes
#define FA_ALLOW_DOWNLOAD (1<<6) // Allow Downloading                0=Yes
#define FA_ALLOW_VIEWLIST (1<<7) // Allow viwing file listings       0=Yes
#define FA_USECDDATPATH   (1<<8) // Use CD/DAT Temporary Path        0=No
#define FA_CatDupeFileCheck (1<<9) // Use Dupe File Check              0=No
//=========================================================================
//***********************
//***********************
//*****  Node_Info  *****  FiLE: NodeInfo_x
//***********************
//***********************  // Add a ton more extra pointers next upgrade.
//=========================================================================
struct node_info
{
 struct Globals *GLOB;

 int  *mode;

 long *fileshouldbe;
 long *timelimit;

 struct User *UserInfo;
 struct SystemData *SystemDataInfo;
 struct NodeData *NodeDataInfo;
 struct Today *TodayInfo;
 struct Iconify *IconInfo;
 struct Editor *EdInfo;

 struct Screen *screen1Info;
 struct Window *windowInfo, *StatusPaneInfo, *iconInfo, *twindowInfo;

 struct IOExtSer *WriteSerReqInfo, *ReadSerReqInfo;
 struct IOStdReq *WriteConReqInfo, *ReadConReqInfo;
 struct IOStdReq *StatWriteReqInfo;

 struct MsgPort *WriteSerPortInfo, *ReadSerPortInfo, *TimerPortInfo;
 struct MsgPort *WriteConPortInfo, *ReadConPortInfo;
 struct MsgPort *StatWritePortInfo;

 struct timerequest *TimerMsgInfo;
 struct Msg_Area *MSGInfo;
 struct File_Area *FILESInfo;
 struct RATES *RATESInfo;
 struct R_SLOTS *R_SLOTSInfo;
 struct Questions *NotUsedAnyMore; // Get rid of in future version
struct Runtimeinfo *RI;            // Get rid of in future version
};
//=========================================================================
//******************************
//*****  System_Info File  ***** FiLE: Node:system_info   (NOT USED YET)
//******************************
//=========================================================================
struct system_info
{
 struct SystemData   *SystemData;
 struct Msg_Area     *Msg_Areas;
 struct File_Area    *File_Areas;
 struct ScreenColors *ScreenColors;
 struct F_KEYS       *FK;

 struct ptable       *ptable;
 char                *inp;

 char *extras[50];
};
//=========================================================================
//****************************
//*****  Struct Letters  ***** FiLE: MsgArea_x.data
//****************************
//=========================================================================
struct Letters  // 170 Bytes
{
 TEXT  Receiver [31],     // ( 31)
       Sender   [31],     // ( 31)
       Subject  [31];     // ( 31)

 UBYTE Type,              // (  1) 0 Public, 1 Private, 3 MassMail
       Kind2;             // (  1) Not used   (Forwarded Msg)

 UWORD Lines,             // (  2) Number of lines in message
       Read;              // (  2) Times the message has been read

 long  Sent,              // (  4) Time posted
       Rcvd;              // (  4) Time Received

 ULONG Area,              // (  4) Msg Area Number
       SubArea,           // (  4) DEAD (NOT USED)
       Number,            // (  4) Actual Msg Number
       NumberInArea,      // (  4) Msg # from Area msg is stored in.
       ReplyFrom,         // (  4) Replied from Msg #
       FirstReply;        // (  4) First Reply to Msg

 // Restrictions

 TEXT  Password[4],       // (  4)
       StateCode[4],      // (  4)
       CountryCode[4];    // (  4)

 UBYTE MinAccessLev,      // (  1) Minimum Access Level to read message
       MaxAccessLev,      // (  1) Maximum Access Level that can read message
       MinAge,            // (  1) Minimum Age
       MaxAge,            // (  1) Maximum Age
       DelDays;           // (  1) Delete after so many days.

 LONGBITS Flags1,         // (  4) Flags 1 (look below)
          Flags2;         // (  4) Flags 2 (look below)

 char extraroom[17];      // ( 18)
};

#define LET_ACTIVE     (1<<0)  // Active/Deleted, 0=Active, 1=Deleted
#define LET_ANONYMOUS  (1<<1)  //
#define LET_LOCKED     (1<<2)  // Locked Msg, 0=No, 1=Yes (can't be deleted)

#define LET_ATTACHFILE (1<<10) // Attached Files? 0=No, 1=Yes
#define LET_DEL_A_FILE (1<<11) // Auto Delete Attached Files? 0=No, 1=Yes

//=========================================================================
struct LettersPointer     //  FiLE: MsgArea_x.point
{
 ULONG SlotPosition,      // (  4)
       FirstNumber,       // (  4)
       LastNumber;        // (  4)
};
//=========================================================================
struct LettersIdx         //  FiLE: MsgArea_x.idx
{
 TEXT  Receiver [31],     // ( 31)
       Sender   [31];     // ( 31)
 ULONG Number;            // (  4)
};
//=========================================================================
struct LettersCSum        //  FiLE: MsgArea_x.csum
{
 UWORD Receiver,          // (  2)
       Sender;            // (  2)
};
//=========================================================================
//**************************
//*****  Today Struct  *****  FiLE: Runtime.data
//**************************
//=========================================================================
struct Today
{
 TEXT   NMName[35],   // ( 35) Name who sent message to next caller
        extra[40];    // ( 40)

 UWORD  CBAUD[20],    // (2x20=40) 300,1200,2400,4800,7200,9600,12000,14400,16800,19200,28800
        AbortedDl,    // (  2)
        AbortedUl,    // (  2)
        UpRes,        // (  2)
        DLRes,        // (  2)
        Users,        // (  2)
        Uploads,      // (  2)
        Downloads,    // (  2)
        Feedback,     // (  2)
        New,          // (  2)
        Messages,     // (  2)
        F_Sysop;      // (  2)

 int    Calls,        // (  4)
        NMAno,        // (  4)
        BBSNumbers,   // (  4)
        Busy,         // (  4)
        extra2,       // (  4)
        extra3,       // (  4)
        Total;        // (  4)

 long   dl_bytes,     // (  4)
        ul_bytes,     // (  4)
        NMDate,       // (  4)
        TODAY,        // (  4)
        L_ext1,       // (  4)
        L_ext2,       // (  4)
        connected;    // (  4)

 TEXT   Last[31];     // ( 31) Last Caller on BBS

 UWORD  CurrentUser;  // (  2)

 TEXT   Reserved[31]; // ( 31) Reserved Caller

 UWORD  CTYPE[20];    // (2x20=40) (0,HST),(1,v32),(2,vFC),(3,v34)

 TEXT   ExtraNotUsed[124]; // (124)
};
//=========================================================================
//*******************
//*****  Rates  *****  FiLE: Baud-x.data (x=Node)
//*******************
//=========================================================================
struct RATES
{
 ULONG MinNewUserBaud,
       MinULBaud[24],
       MinDLBaud[24],
       MinConnectBaud[24];
};
//=========================================================================
//****************************
//*****  Presets Struct  *****  FiLE: Presets.Data
//****************************
//=========================================================================
struct Defaults
{
 char     MB[41],
          FB[41];

 UBYTE    Security,
          F_Ratio,
          B_Ratio,
          IdleTime,
          ViewMode;

 UWORD    DayCredits,
          FileCredits,
          WeedDays,
          ReduceDays,
          ReducedAccess;

 UWORD    Limit_Calls,
          Limit_Posts,
          Limit_ULFiles,
          Limit_DLFiles,
          Limit_Time,
          Limit_TimeBank,
          Limit_ChatTime;
 ULONG    Limit_ULBytes,
          Limit_DLBytes;

 UWORD    Total_ULFiles,
          Total_DLFiles;
 ULONG    Total_ULBytes,
          Total_DLBytes,
          ByteCredits,
          PersonalBytes;

 LONGBITS NFlags1,
          NFlags2,
          SFlags1,
          SFlags2,
          CatFlags;

 char     CExtra[110];
 UBYTE    UBExtra[50];
 UWORD    UWExtra[25];
 ULONG    ULExtra[12];
};
//=========================================================================
//*******************************
//*****  Flag Files Struct  *****
//*******************************
//=========================================================================
struct FLAG
{
 TEXT  FileName[31],         // ( 31)
       ShortDesc[46];        // ( 46)
 ULONG Area,                 // (  4)
       SubArea,              // (  4)
       Number,               // (  4)
       Bytes;                // (  4)
 BYTE  COST;                 // (  1) 0=Normal , 1=Free
 char  filler[20];           // ( 20)
};
//=========================================================================
//****************************
//*****  Catalog Struct  *****  FiLE: Catalog_x.data
//****************************   132
//=========================================================================
struct Catalogs
{
 ULONG    SeekPosition;      // (  4) Seek Position for Description Entry
 UWORD    SizeOfEntry;       // (  2) Size to Read In

 TEXT     FileName[31],      // ( 31)
          Uploader[31],      // ( 31)
          Password[4],       // (  4)
          DateComment[9];    // (  9) Date Comment Overlay

 BYTE     Security,          // (  1) 1 = Public, -1 = Sysop, -2 = UnVal, -3 = BadArchive
          Level,             // (  1) Secuirty Level Number to download/view.
          LevelType;         // (  1) Secuirty Type (Below, Equal too, Greather than

 WORD     PurgeDays,         // (  2) Days before Auto Purge
          ReceiverSlot,      // (  2) Slot Number of Receiver
          TimesDL;           // (  2) Times Downloaded

 long     DateU,             // (  4) Date file was uploaded
          LastDateD,         // (  4) Last Date file was downloaded
          DAfterDate,        // (  4) Date that file can start being downloaded
          PurgeDate,         // (  4) Purge file after this date.
          ExtraDate;         // (  4)

 ULONG    Bytes;             // (  4) Filesize

 UWORD    FilePayBack,       // (  2) File Payback to U/L
          FileCost;          // (  2) File Cost to D/L
 ULONG    BytePayBack,       // (  4) Byte PayBack to U/L
          ByteCost;          // (  4) Byte Cost for D/L

 UWORD    BestCPS;           // (  2)

 LONGBITS Flags;             // (  4) Active,Free,ExtDesc,DLock,ELock,HDOnline,ArcTest- 32 Togglable Bits
};
//=========================================================================
//*********************************
//*****  Fast Catalog Struct  *****  FiLE: Catalog_x.seek
//*********************************   37 bytes
//=========================================================================
struct SeekCatalogs
{
 ULONG    SeekPosition;      // (  4) Seek Position for Description Entry
 UWORD    SizeOfEntry;       // (  2) Size to Read In
 TEXT     FileName[31];      // ( 31)
};
//=========================================================================
//*****************************************
//*****  Catalog Descriptions Struct  *****
//*****************************************
//=========================================================================
struct CatalogsD   // Just a work structure, does NOT match any files.
{
 TEXT DateU[9],
      LastDateD[9],
      Receiver[31];

 TEXT Line[20][46];
};
//=========================================================================
struct R_SLOTS
{
 UBYTE MinAccess00[24],
       MinAccess15[24],
       MinAccess30[24],
       MinAccess45[24];
};
/* the struct to tell the protocol what files are to be downloaded */
//=========================================================================
struct Down_Load
{
 TEXT File[255],
      FileName[31],
      ShortDesc[46],
      ex_string[123];
 int  Area,
      Cost,
      FileNumber;

 ULONG SubArea;

 int  ex_ints[8];
 long Bytes;
 LONGBITS Flags;         // (1<<0) = CD Rom Path or not.
 long ex_longs[9];
};
//=========================================================================
// the protocol, fills in these stats about each file downloaded so the bbs
// knows what happened, and how to charge the user for the downloads
//=========================================================================
struct DownLoad_Status
{
 TEXT  File[255],
       ex_strings[5][255];

 int   Cost,                        // 1: Free dl,  0: charge normal
       Area,
       Good,
       Errors,
       Mins,
       Secs,
       FileNumber;

 ULONG SubArea;

 int   ex_ints[6];

 long  First_Byte_Sent,
       Last_Byte_Sent,
       Bytes_To_Charge,
       Files_To_Charge,
       CPS,
       FileSize,
       Seconds,
       ex_longs[9];
};
//=========================================================================
struct Name  // Accounts Index File
{
 char Username[31];
};
//=========================================================================
struct TempMessage // New Tempest Server Structure.
{
 struct Message Msg;
 UWORD  command;     // 2 bytes
 UWORD  node;        // 2 bytes

 WORD   word1;       // 2 byte variables.
 WORD   word2;
 WORD   word3;

 LONG   long1;       // 4 byte variables.
 LONG   long2;
 LONG   long3;

 ULONG  ulong1;      // 4 byte unsigned.
 ULONG  ulong2;
 ULONG  ulong3;

 char string[200];   // string for passing strings.
 char extra[200];    // Extra space for future variables.
};
//=========================================================================
#include <tempest/Private.h>




/*
struct Indx  // NOT USED ANYMORE!!
{
 int Active,
     FirstMsgNumber,
     LastMsgNumber,
     LastMsgSlot;
};

struct OldLetters // NOT USED ANYMORE!!
{
 TEXT  Receiver [31],
       Sender   [31],
       Subject  [31],
       Password [9];

 long  Sent,
       Rcvd;

 int   Number,         //  the number of the actuall message
       MsgArea,        //  what area the message was written in
       Delete,         //  Delete  0:OK  1:DELETED
       Reply,          //  This message was replied from
       Ano,            //  0: normal 1:Quit Sender
       Read,           //  Times the message has been read
       Status;         //  0=Private 1=Public 2=Password 3=Priority
                       //  4=Fowarded Mail
 LONGBITS Flags; // 0=Attached Files?
 int   Locked;         //  0: na kill it if needed  1:Keep it
};
#define LET_ATTACHFILE (1<<10) // Attached Files? 0=No, 1=Yes
#define LET_DEL_A_FILE (1<<11) // Auto Delete Attached Files? 0=No, 1=Yes
*/
